<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Http\Controllers\Admin;
use Illuminate\Http\Request;
use App\Http\Helper\Helper;
use App\Validators\LiveArchieveVideoValidator;
use App\Managers\LiveArchieveVideo\LiveArchieveVideoManager;
use Illuminate\Support\Facades\Mail;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\Redirect;
use Illuminate\Support\Facades\DB;

class AdminLiveArchieveController extends Controller
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->liveArchieveVideoValidator = new LiveArchieveVideoValidator();
        $this->liveArchieveVideoManager = new LiveArchieveVideoManager();
    }
    
    public function list()
    {
        $liveVideos = $this->liveArchieveVideoManager->get();
        return view('/admin/live_archieve/list')->with('liveVideos', $liveVideos);
    }
    
    public function add(Request $request)
    {
        if($request->exists('data'))
        {
            $data = $request->get('data');
            $data['UUID'] = $this->helper->addUuid();

            $validation = $this->liveArchieveVideoValidator->add($data);
            if($validation)
            {
                return redirect()->back()->withErrors($validation)->withInput();
            }

            $res = $this->liveArchieveVideoManager->add($data);
            if(!$res)
            {
                return redirect()->back()->withErrors(array('message' => 'Something went wrong'))->withInput();
            }
            
            return redirect('/admin/live/archieve')->withErrors(array('message' => 'Live Video Added Successully'));
        }
        return view('/admin/live_archieve/add');
    }

    public function edit(Request $request, $id)
    {
        $liveArchieveVideo = $this->liveArchieveVideoManager->where('UUID', $id)->first();
        if(!$liveArchieveVideo)
        {
            return redirect()->back()->withErrors($validation)->withInput();
        }

        if($request->exists('data'))
        {
            $data = $request->get('data');
            $data['UUID'] = $this->helper->addUuid();

            $validation = $this->liveArchieveVideoValidator->update($data);
            if($validation)
            {
                return redirect()->back()->withErrors($validation)->withInput();
            }

            $res = $this->liveArchieveVideoManager->updateData($data, $id);
            if(!$res)
            {
                return redirect()->back()->withErrors(array('message' => 'Something went wrong'))->withInput();
            }
            
            return redirect('/admin/live/archieve')->withErrors(array('message' => 'Live Video Updated Successully'));
        }

        return view('/admin/live_archieve/edit')->with('liveArchieveVideo', $liveArchieveVideo);
    }

    public function deleteData($UUID)
    {
        $res = $this->liveArchieveVideoManager->deleteData($UUID);
        if(!$res){
            return response()->json(['Something went wrong'], 500);
            exit;
        }
        
        return response()->json(['Live Archieve Video Deleted'], 200);
        exit;
    }
}