<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\Formation;
use App\Managers\Formation\FormationModel;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;
use App\Managers\FormationPositions\FormationPositionsManager;
use App\Managers\SchedulePreMatchFormation\SchedulePreMatchFormationManager;
use App\Http\Helper\Helper;

class FormationManager extends FormationModel
{
    public function __construct()
    {
        $this->helper = new Helper();
        $this->formationPositions = new FormationPositionsManager();
        $this->schedulePreMatchFormation = new SchedulePreMatchFormationManager();
    }

    public function add($columns, $name)
    {
        DB::beginTransaction();
        try 
        {
            $data['name'] = $name;
            $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
            $data['user_id'] = Session::get('admin');
            $data['UUID'] = $this->helper->addUuid();
            $formationID = $this->insertGetId($data);
            if(!$formationID)
            {
                return 0;
            }
            
            $formation = $this->where('id', $formationID)->first();
            
            if(empty($columns))
            {
                return 0;
            }
            foreach($columns AS $key => $column)
            {
                $data1['formation_id'] = $formation->UUID;
                $data1['position_columns_id'] = $key;
                $data1['UUID'] = $this->helper->addUuid();
                $data1['user_id'] = Session::get('admin');
                $data1['created_at'] = $data1['updated_at'] = date("Y-m-d H:i:s");
                $ins = $this->formationPositions->insert($data1);
                if(!$ins)
                {
                    return 0;
                }
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function updateData($columns, $name, $UUID)
    {
        DB::beginTransaction();
        try 
        {
            $data['name'] = $name;
            $data['updated_at'] = date("Y-m-d H:i:s");
            $update = $this->where('UUID', $UUID)->update($data);
            if(!$update)
            {
                return 0;
            }
            
            if(empty($columns))
            {
                return 0;
            }
            
            $formation = $this->formationPositions->where('formation_id', $UUID)->first();
            
            if($formation)
            {
                $del = $this->formationPositions->where('formation_id', $UUID)->update(array('inactive' => 1));
                if(!$del)
                {
                    return 0;
                    exit;
                }
                
            }
            
            foreach($columns AS $key => $column)
            {
                $res = $this->formationPositions->where('position_columns_id', $key)->where('inactive',1)->first();
                if($res)
                {
                    $columnAdd = array();
                    $columnAdd['inactive'] = 0;
                    $col = $this->formationPositions->updateData($columnAdd, $res->UUID);
                    if(!$col)
                    {
                        return 0;
                        exit;
                    }
                }
                else
                {
                    $data1['formation_id'] = $UUID;
                    $data1['position_columns_id'] = $key;
                    $data1['UUID'] = $this->helper->addUuid();
                    $data1['user_id'] = Session::get('admin');
                    $data1['created_at'] = $data1['updated_at'] = date("Y-m-d H:i:s");
                    $ins = $this->formationPositions->insert($data1);
                    if(!$ins)
                    {
                        return 0;
                    }
                }
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
        
    }
    
    public function confirmProposal($id)
    {
        $data['confirm'] = 1;
        return $this->where('UUID', $id)->update($data);
    }
    
    public function denyProposal($id)
    {
        $data['reject'] = 1;
        return $this->where('UUID', $id)->update($data);
    }
    
    public function deleteFormation($UUID)
    {
        DB::beginTransaction();
        try 
        {
            $res = $this->formationPositions->where('formation_id', $UUID)->delete();
            $res = $this->schedulePreMatchFormation->where('formation_id', $UUID)->delete();
            
            $res = $this->where('UUID', $UUID)->delete();
            if(!$res)
            {
                DB::rollback();
                return 0;
                exit;
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
            exit;
        }
    }
}