<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\LiveProposalLikeCount;
use App\Managers\LiveProposalLikeCount\LiveProposalLikeCountModel;
use Illuminate\Support\Facades\Session;
use Illuminate\Support\Facades\DB;
use App\Managers\LiveProposal\LiveProposalManager;
use App\Managers\Paypal\PaypalManager;
use App\Http\Helper\Helper;
class LiveProposalLikeCountManager extends LiveProposalLikeCountModel
{
    public function __construct()
    {
         $this->paypalManager = new PaypalManager();
         $this->helper = new Helper();
    }

    public function addLike($id, $noOfLikes)
    {
        DB::beginTransaction();
        try 
        {
            $this->liveProposalManager = new LiveProposalManager();
            $userBalanceVote = $noOfLikes;
            
            $data['live_proposal_id'] = $id;
            $data['no_of_likes'] = $noOfLikes;
            $data['user_id'] = Session::get('general');
            $data['UUID'] = $this->helper->addUuid();
            $res = $this->insert($data);
            if(!$res)
            {
                return 0;
            }
            
            $updateProposalLike = $this->liveProposalManager->where('UUID', $id)->update(array('no_of_likes' => DB::raw('no_of_likes+' . $noOfLikes)));
            if(!$updateProposalLike)
            {
                return 0;
            }
            
            $votes = $this->paypalManager->getAllCreditsOfUser(Session::get('general'));
            $end = 0;

            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function getTotalLikesByUser($liveProposalLikeCountID, $userID)
    {
        return $this->select(DB::raw('SUM(no_of_likes) AS total_likes'))->where('user_id', $userID)->where('live_proposal_id', $liveProposalLikeCountID)->first();
    }
}