<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class AddVotesToSubstitutionProposalTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::table('substitution_proposal', function (Blueprint $table) {
            $table->dropColumn('player_no');
            $table->uuid('schedule_player_id')->after('substituted_player_id');
            $table->bigInteger('votes')->after('schedule_player_id')->default(0);

            $table->foreign('schedule_player_id')->references('UUID')->on('schedule_players');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::table('substitution_proposal', function (Blueprint $table) {
            //
        });
    }
}
